love.graphics.setDefaultFilter("nearest", "nearest")

_G.loader = require "loader"
_G.import = loader.import

local events = {}
local world = import "world" ()

local worldtypes = {}

_G. asyncfs = require "asyncfs"

worldtypes.normal = {
    hillamp = 5,
    mountainamp = 5,
    oceanamp = 5,
    squish = 10,
    sealevel = 6,
    treefrequency = 0.2,
}

worldtypes.flat = {
    hillamp = 0,
    mountainamp = 0,
    oceanamp = 0,
    sealevel = 10,
    treefrequency = 0,
}

local genoptions = worldtypes.normal

world:init()
world.generatorsettings = genoptions

local shader = love.graphics.newShader("shaders/pal.glsl")

love.math.setRandomSeed(os.clock())

local canvas = love.graphics.newCanvas(love.graphics.getWidth(), love.graphics.getHeight())

local offsetx = 0
local offsety = 0

local useshader = true

function love.load(args, arg)

end

local function regenerate()
    local prevseed = world.seed
    world = require "world" ()
    world:init()
    world.debug = true
    world.generatorsettings = genoptions
    -- world.seed = prevseed + 0.02
end

function love.update(dt)
    asyncfs.update()
    if love.keyboard.isDown "r" then
        regenerate()
    end
    world:update(dt, events, true)
    events = {}
end

function love.draw()
    love.graphics.setCanvas(canvas)
    world:draw()
    love.graphics.setCanvas()
    if useshader then
        love.graphics.setShader(shader)
    end
    love.graphics.draw(canvas)
    love.graphics.setShader()
end

function love.keyreleased(...)
    events[#events+1] = {
        type = "keyreleased",
        args = {...}
    }
end

function love.mousepressed(...)
    events[#events+1] = {
        type = "mousepressed",
        args = {...}
    }
end

function love.mousereleased(...)
    events[#events+1] = {
        type = "mousereleased",
        args = {...}
    }
end

function love.wheelmoved(...)
    events[#events+1] = {
        type = "wheelmoved",
        args = {...}
    }
end

function love.keypressed(...)
    local key = ...
    events[#events+1] = {
        type = "keypressed",
        args = {...}
    }
    if key == "l" then
        useshader = not useshader
    end
    if key == "k" then
        world:save("tempworld")
    end
    if key == "j" then
        world:load("tempworld")
    end
    if key == "f" then
        world.debug = not world.debug
    end
    if (love.keyboard.isDown "lalt" or love.keyboard.isDown "ralt") and key == "return" then
        love.window.setFullscreen(not love.window.getFullscreen())
    end
end

function love.resize()
    canvas = love.graphics.newCanvas(love.graphics.getWidth(), love.graphics.getHeight())
end