vec4 effect(vec4 color, Image tex, vec2 texture_coords, vec2 screen_coords)
{
    const int len = 4;
    vec4 palettecolors[len];
    palettecolors[0] = vec4(0, 25, 0, 255)/255;
    palettecolors[1] = vec4(50, 75, 50, 255)/255;
    palettecolors[2] = vec4(120, 155, 120, 255)/255;
    palettecolors[3] = vec4(210, 255, 210, 255)/255;
    vec4 texturecolor = Texel(tex, texture_coords) * color;
    vec4 finalcolor = texturecolor;
    float dist = 4.0;
    for (int i = 0; i < len; i++) {
        vec4 col = palettecolors[i];
        vec4 diff = texturecolor - col;
        float currentdist = abs(diff[0]) + abs(diff[1]) + abs(diff[2]) + abs(diff[3]);
        if (currentdist < dist) {
            dist = currentdist;
            finalcolor = col;
        }
    }
    return finalcolor;
}