vec4 effect(vec4 color, Image tex, vec2 texture_coords, vec2 screen_coords)
{
    const int len = 33;
    vec4 palettecolors[len];

    palettecolors[len-1] = vec4(0, 0, 0, 0)/255;

    palettecolors[0] = vec4(0, 0, 0, 255)/255;
    palettecolors[1] = vec4(29, 43, 83, 255)/255;
    palettecolors[2] = vec4(126, 37, 83, 255)/255;
    palettecolors[3] = vec4(0, 135, 81, 255)/255;
    palettecolors[4] = vec4(171, 82, 54, 255)/255;
    palettecolors[5] = vec4(95, 87, 79, 255)/255;
    palettecolors[6] = vec4(194, 195, 199, 255)/255;
    palettecolors[7] = vec4(255, 241, 232, 255)/255;
    palettecolors[8] = vec4(255, 0, 77, 255)/255;
    palettecolors[9] = vec4(255, 163, 0, 255)/255;
    palettecolors[10] = vec4(255, 236, 39, 255)/255;
    palettecolors[11] = vec4(0, 288, 54, 255)/255;
    palettecolors[12] = vec4(41, 173, 255, 255)/255;
    palettecolors[13] = vec4(131, 118, 156, 255)/255;
    palettecolors[14] = vec4(255, 119, 168, 255)/255;
    palettecolors[15] = vec4(255, 204, 170, 255)/255;

    palettecolors[16] = vec4(41, 24, 20, 255)/255;
    palettecolors[17] = vec4(17, 29, 53, 255)/255;
    palettecolors[18] = vec4(66, 33, 54, 255)/255;
    palettecolors[19] = vec4(18, 83, 89, 255)/255;
    palettecolors[20] = vec4(116, 47, 41, 255)/255;
    palettecolors[21] = vec4(73, 51, 59, 255)/255;
    palettecolors[22] = vec4(162, 136, 121, 255)/255;
    palettecolors[23] = vec4(243, 239, 125, 255)/255;
    palettecolors[24] = vec4(190, 18, 80, 255)/255;
    palettecolors[25] = vec4(255, 108, 36, 255)/255;
    palettecolors[26] = vec4(168, 231, 46, 255)/255;
    palettecolors[27] = vec4(0, 181, 67, 255)/255;
    palettecolors[28] = vec4(6, 90, 181, 255)/255;
    palettecolors[29] = vec4(117, 70, 101, 255)/255;
    palettecolors[30] = vec4(225, 110, 89, 255)/255;
    palettecolors[31] = vec4(225, 157, 129, 255)/255;

    vec4 texturecolor = Texel(tex, texture_coords) * color;
    vec4 finalcolor = texturecolor;
    float dist = 4.0;
    for (int i = 0; i < len; i++) {
        vec4 col = palettecolors[i];
        float currentdist = abs(texturecolor[0] - col[0]) + abs(texturecolor[1] - col[1]) + abs(texturecolor[2] - col[2]);
        if (currentdist < dist) {
            dist = currentdist;
            finalcolor = col;
        }
        if (currentdist == 0.0) {
            return finalcolor;
        }
    }
    return finalcolor;
}