local sky = {}
sky.color = {17/255, 29/255, 53/255}
function sky.draw(world, x, y)
    x = x * 2 / 3
    y = y * 2 / 3
    love.graphics.setColor(sky.color)
    love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth()/world.scale, love.graphics.getHeight()/world.scale)
    love.graphics.setColor(1, 1, 1)
    for xpos = 0, love.graphics.getWidth()/4/world.scale do
        for ypos = 0, love.graphics.getHeight()/4/world.scale do
            local noise = love.math.noise(xpos + math.floor(x) + math.floor(world.seed * 3141) % 1000, ypos + math.floor(y))
            local brightness = love.math.noise((xpos + x)/25 + world.time/50, (ypos + y)/25)
            local xoffset = math.floor(love.math.noise(xpos + math.floor(x) + 100, world.time / 1500) * 4)
            local yoffset = math.floor(love.math.noise(ypos + math.floor(y) + 100, world.time / 1500) * 4)
            local p = 0.02
            if noise < p then
                if love.math.noise(xpos + x, ypos + y) > 0.9 then
                    brightness = brightness - 0.6
                    love.graphics.setColor(brightness/2, brightness, 0.5 + brightness / 2)
                    love.graphics.rectangle("fill", xpos*4 + xoffset - x%1 * 4 -1, ypos*4 + yoffset - y%1 * 4, 3, 1)
                    love.graphics.rectangle("fill", xpos*4 + xoffset - x%1 * 4, ypos*4 + yoffset - y%1 * 4 -1, 1, 3)
                    brightness = brightness + 0.6
                end
                love.graphics.setColor(brightness/2, brightness, 0.5 + brightness / 2)
                love.graphics.rectangle("fill", xpos*4 + xoffset - x%1 * 4, ypos*4 + yoffset - y%1 * 4, 1, 1)
            end
        end
    end
    love.graphics.setColor(1, 1, 1)
end
return sky