local base = require "types.base"

local self = {}

self.image = "sprites/items.png"

self.quad = {
    x = 0,
    y = 0,
    width = 6,
    height = 6
}

self.width = 6
self.height = 6

self.floats = true

self.maxanimtimer = 24

function self:init(world)
    self.animtimer = 0
end

function self:update(world, dt)
    self.animtimer = self.animtimer + 1
    if self.animtimer >= self.maxanimtimer then
        self.animtimer = 0
    end
    base.move(self, world)
    self.mirrored = false
end

function self:draw(world)
    local offsety = 0
    local bright = (self.animtimer) % self.maxanimtimer > self.maxanimtimer / 2
    if (self.animtimer + self.maxanimtimer / 4) % self.maxanimtimer > self.maxanimtimer / 2 then
        offsety = 1
    end
    if bright then
        love.graphics.setShader(loader.shader("shaders/bright.glsl"))
    end
    base.draw(self, world, 0, offsety)
    if bright then
        love.graphics.setShader()
    end
end

return self